local _, MNT4 = ...

--[==[Here are tags you may use to customize the above macros:
	<f> == Random Flying Mount
	<g> == Random Ground Mount
	<w> == Random Water Mount falls back on <gf> if no watermount is found
	<a> == Random Ahn'Qiraj Mount
	<v> == Random Vashj'ir Mount
	<s#> == will be replaced with the spellname of spellid #
(will not insert rank so will scale)]==]--

local MountTypeLookup = {
	['g'] = 'ground',
	['f'] = 'air',
	['w'] = 'water',
	['a'] = "Temple of Ahn'Qiraj",
	['v'] = "Vashj'ir",
}
local rMountTypeLookup = {}
for k,v in pairs(MountTypeLookup) do
	rMountTypeLookup[v] = k
end

-- /spew MNT4:ParseMacro([[#showtooltip\n/cast <primary>\n/cast <primary>\n/cast <secondary>]])
function MNT4:ParseMacro(macrotext)
	macrotext = macrotext or '' -- use a empty string if macrotext is nil
	local mounts = {}
	local mountscache = {}
	local valid = true
	for tag in string.gmatch(macrotext, "<(%w-)>") do
		if not MountTypeLookup[tag] then
			if tag == 'primary' then
				tag = rMountTypeLookup[MNT4.availablemounts[1]]
			elseif tag == 'secondary' then
				tag = rMountTypeLookup[MNT4.availablemounts[2]]
			end
		end
		if (not mountscache[tag]) then
			if next(self.currentMountTable[MountTypeLookup[tag]]) then
				mountscache[tag] = GetSpellInfo(self:GetWeightedRandom(self.currentMountTable[MountTypeLookup[tag]], MountTypeLookup[tag]))
			else
				mountscache[tag] = UNKNOWN
			end
		end
		if mountscache[tag] == UNKNOWN then
			valid = false
		end
		mounts[#mounts+1] = mountscache[tag]
	end
	return valid, string.format(string.gsub(macrotext, '<%w->', '%%s()'), unpack(mounts))
end

