local _, MNT4 = ...

MNT4.MacroEditorFrame = {}
function MNT4.MacroEditorFrame:IsVisible()
	return false
end

local tempTable = {}
local function TableSize(t)
	wipe(tempTable)
	for k in pairs(t) do
		tempTable[#tempTable+1] = k
	end
	return #tempTable
end
local NumMacros

function MNT4.MacroEditorFrame:Show()
	local frame = MNT4:GetWidget("frame", UIParent)
		frame:SetPoint("CENTER")
		frame:SetWidth(550)
		frame:SetHeight(400)
		frame:SetText("Mounted Macro Editor")
	
	local SAVEbutton = MNT4:GetWidget("button", frame)
		SAVEbutton:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 13, 13)
		SAVEbutton:SetWidth((frame:GetWidth()-26)/3)
		SAVEbutton:SetText(SAVE)
	frame.SAVEbutton = SAVEbutton
	
	local DELETEbutton = MNT4:GetWidget("button", frame)
		DELETEbutton:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -13, 13)
		DELETEbutton:SetWidth((frame:GetWidth()-26)/3)
		DELETEbutton:SetText(DELETE)
	frame.DELETEbutton = DELETEbutton
	
	local CANCELbutton = MNT4:GetWidget("button", frame)
		CANCELbutton:SetPoint("BOTTOMRIGHT", DELETEbutton, "BOTTOMLEFT")
		CANCELbutton:SetPoint("BOTTOMLEFT", SAVEbutton, "BOTTOMRIGHT")
		CANCELbutton:SetText(CANCEL)
	frame.CANCELbutton = CANCELbutton
	
	local numcharacters = MNT4:GetWidget("title", frame)
		numcharacters:SetPoint("LEFT", SAVEbutton, "LEFT")
		numcharacters:SetPoint("BOTTOMRIGHT", DELETEbutton, "TOPRIGHT")
		numcharacters:SetText("len")
	frame.numcharacters = numcharacters
	
	local nametitle = MNT4:GetWidget("title", frame)
		nametitle:SetPoint("TOPLEFT", frame, "TOPLEFT", 13, -20)
		nametitle:SetPoint("RIGHT", frame, "RIGHT", -13, 0)
		nametitle:SetText("Macro Name")
		nametitle.label:SetJustifyH("LEFT")
	frame.nametitle = nametitle
	
	local name = MNT4:GetWidget("editbox", frame)
		name:SetPoint("TOPLEFT", nametitle, "BOTTOMLEFT", 0,-1)
		name:SetPoint("TOPRIGHT", nametitle, "BOTTOMRIGHT", 0,-1)
	frame.name = name

	local MacroEditBox = MNT4:GetWidget("scrollingeditbox", frame)
		MacroEditBox:SetPoint("TOPLEFT", name, "BOTTOMLEFT", 0,-2)
		MacroEditBox:SetPoint("BOTTOMRIGHT", numcharacters, "TOPRIGHT")
	frame.MacroEditBox = MacroEditBox	

	MacroEditBox.textArea:SetScript("OnTextChanged", function(self)
		local length = string.gsub(MacroEditBox:GetText(), '<%w->', MNT4.longestMountName):len()
		numcharacters:SetText(("Macro can be %d character(s) long"):format(length))
		if length > 255 then
			numcharacters:SetTextColor(1, .1, .1, 1)
		else
			numcharacters:SetTextColor(.1, 1, .1, 1)
		end
		if name:GetText():len() > 0 and MacroEditBox:GetText():len() > 0 then
			SAVEbutton:Enable()
		else
			SAVEbutton:Disable()
		end
	end)

	name.textArea:SetScript("OnTextChanged", function()
		if name:GetText():len() > 0 and MacroEditBox:GetText():len() > 0 then
			SAVEbutton:Enable()
		else
			SAVEbutton:Disable()
		end
		if MNT4.db.global.macros[MNT4.MacroEditorType][name:GetText()] and NumMacros > 1 then
			DELETEbutton:Enable()
		else
			DELETEbutton:Disable()
		end
	end)
	
	CANCELbutton:SetScript("OnClick", function(self, button)
		MNT4.MacroEditorFrame:Hide()
	end)
	
	SAVEbutton:SetScript("OnClick", function(self, button)
		local MacroName = MNT4.MacroEditorFrame.name:GetText()
		local MacroText = MNT4.MacroEditorFrame.MacroEditBox:GetText()
		MNT4.db.profile.macros[MNT4.MacroEditorType] = MacroName
		MNT4.db.global.macros[MNT4.MacroEditorType][MacroName] = MacroText
		MNT4.MacroEditorFrame:Hide()
		MNT4:UpdateMacroFrame()
		MNT4:UpdateMacro()
	end)
	
	DELETEbutton:SetScript("OnClick", function(self, button)
		MNT4.db.global.macros[MNT4.MacroEditorType][name:GetText()] = nil
		MNT4.db.profile.macros[MNT4.MacroEditorType] = next(MNT4.db.global.macros[MNT4.MacroEditorType])
		MNT4.MacroEditorFrame:Hide()
		MNT4:UpdateMacroFrame()
		MNT4:UpdateMacro()
	end)
	
	MNT4.MacroEditorFrame = frame 
end

function MNT4:OpenMacroEditor(edit)
	self.MacroEditorFrame:Show()
	NumMacros = TableSize(MNT4.db.global.macros[MNT4.MacroEditorType])
	if edit then
		MNT4.MacroEditorFrame.name:SetText(self.db.profile.macros[MNT4.MacroEditorType])
		MNT4.MacroEditorFrame.MacroEditBox:SetText(self.db.global.macros[MNT4.MacroEditorType][self.db.profile.macros[MNT4.MacroEditorType]])
	else
		MNT4.MacroEditorFrame.name:SetText('')
		MNT4.MacroEditorFrame.MacroEditBox:SetText('')
	end
	if MNT4.db.global.macros[MNT4.MacroEditorType][MNT4.MacroEditorFrame.name:GetText()] and NumMacros > 1 then
		MNT4.MacroEditorFrame.DELETEbutton:Enable()
	else
		MNT4.MacroEditorFrame.DELETEbutton:Disable()
	end
end

