local _, MNT4 = ...


MNT4.MacroFrame = {}
function MNT4.MacroFrame:Show()
	local frame = CreateFrame("frame", nil, UIParent)
		frame:SetPoint("CENTER")
		frame:SetWidth(300)
		frame:SetHeight(400)
		frame:Show()
	
	local offsetH = MNT4.MainFrame.childframe:GetHeight()/6
	
	------------------------------
	----------Two Mounts----------
	------------------------------
	
	local TwoMountTitle = MNT4:GetWidget("title", frame)
		TwoMountTitle:SetPoint("TOPLEFT", frame, "TOPLEFT", 2, 0)
		TwoMountTitle:SetPoint("RIGHT", frame, "RIGHT", -2, 0)
		TwoMountTitle:SetText("Dual Mount Option Macro")
	frame.TwoMountTitle = TwoMountTitle

	local TwoMountDropdown = MNT4:GetWidget("dropdownbutton", frame)
		TwoMountDropdown:SetPoint("TOPLEFT", TwoMountTitle, "BOTTOMLEFT", 0,-4)
		TwoMountDropdown:SetPoint("RIGHT", frame, "CENTER", 0,-2)
		TwoMountDropdown.__Type = "TwoMounts"
	frame.TwoMountDropdown = TwoMountDropdown

	local TwoMountEditButton = MNT4:GetWidget("button", frame)
		TwoMountEditButton:SetPoint("TOPLEFT", TwoMountDropdown, "TOPRIGHT", 2, 1)
		TwoMountEditButton:SetPoint("RIGHT", TwoMountTitle, "RIGHT", 0, 0)
		TwoMountEditButton:SetText("Edit Macro")
		TwoMountEditButton.__Type = "TwoMounts"
	frame.TwoMountEditButton = TwoMountEditButton
	
	local TwoMountEditBox = MNT4:GetWidget("scrollingeditbox", frame)
		TwoMountEditBox:SetPoint("TOPLEFT", TwoMountDropdown, "BOTTOMLEFT", 0,-2)
		TwoMountEditBox:SetPoint("RIGHT", TwoMountTitle, "RIGHT", 0, 0)
		TwoMountEditBox:SetPoint("BOTTOM", frame, "CENTER", 0, offsetH)
		TwoMountEditBox.textArea:EnableMouse(false)
		TwoMountEditBox.textArea:SetTextColor(.5, .5, .5, 1)
	frame.TwoMountEditBox = TwoMountEditBox	
	
	
	-----------------------------
	----------One Mount----------
	-----------------------------
	local OneMountTitle = MNT4:GetWidget("title", frame)
		OneMountTitle:SetPoint("TOPLEFT", TwoMountEditBox, "BOTTOMLEFT", 0, 0)
		OneMountTitle:SetPoint("RIGHT", frame, "RIGHT", -2, 0)
		OneMountTitle:SetText("Single Mount Option Macro")
	frame.OneMountTitle = OneMountTitle

	local OneMountDropdown = MNT4:GetWidget("dropdownbutton", frame)
		OneMountDropdown:SetPoint("TOPLEFT", OneMountTitle, "BOTTOMLEFT", 0,-4)
		OneMountDropdown:SetPoint("RIGHT", frame, "CENTER", 0,-2)
		OneMountDropdown.__Type = "OneMount"
	frame.OneMountDropdown = OneMountDropdown

	local OneMountEditButton = MNT4:GetWidget("button", frame)
		OneMountEditButton:SetPoint("TOPLEFT", OneMountDropdown, "TOPRIGHT", 2, 1)
		OneMountEditButton:SetPoint("RIGHT", OneMountTitle, "RIGHT", 0, 0)
		OneMountEditButton:SetText("Edit Macro")
		OneMountEditButton.__Type = "OneMount"
	frame.OneMountEditButton = OneMountEditButton
	
	local OneMountEditBox = MNT4:GetWidget("scrollingeditbox", frame)
		OneMountEditBox:SetPoint("TOPLEFT", OneMountDropdown, "BOTTOMLEFT", 0,-2)
		OneMountEditBox:SetPoint("RIGHT", OneMountTitle, "RIGHT", 0, 0)
		OneMountEditBox:SetPoint("BOTTOM", frame, "CENTER", 0, -1*offsetH)
		OneMountEditBox.textArea:EnableMouse(false)
		OneMountEditBox.textArea:SetTextColor(.5, .5, .5, 1)
	frame.OneMountEditBox = OneMountEditBox
	
	
	-----------------------------
	----------No Mounts----------
	-----------------------------
	local NoMountTitle = MNT4:GetWidget("title", frame)
		NoMountTitle:SetPoint("TOPLEFT", OneMountEditBox, "BOTTOMLEFT", 0, 0)
		NoMountTitle:SetPoint("RIGHT", frame, "RIGHT", -2, 0)
		NoMountTitle:SetText("No Mount Option Macro")
	frame.NoMountTitle = NoMountTitle

	local NoMountDropdown = MNT4:GetWidget("dropdownbutton", frame)
		NoMountDropdown:SetPoint("TOPLEFT", NoMountTitle, "BOTTOMLEFT", 0,-4)
		NoMountDropdown:SetPoint("RIGHT", frame, "CENTER", 0,-2)
		NoMountDropdown.__Type = "NoMounts"
	frame.NoMountDropdown = NoMountDropdown

	local NoMountEditButton = MNT4:GetWidget("button", frame)
		NoMountEditButton:SetPoint("TOPLEFT", NoMountDropdown, "TOPRIGHT", 2, 1)
		NoMountEditButton:SetPoint("RIGHT", NoMountTitle, "RIGHT", 0, 0)
		NoMountEditButton:SetText("Edit Macro")
		NoMountEditButton.__Type = "NoMounts"
	frame.NoMountEditButton = NoMountEditButton
	
	local NoMountEditBox = MNT4:GetWidget("scrollingeditbox", frame)
		NoMountEditBox:SetPoint("TOPLEFT", NoMountDropdown, "BOTTOMLEFT", 0,-2)
		NoMountEditBox:SetPoint("RIGHT", NoMountTitle, "RIGHT", 0, 0)
		NoMountEditBox:SetPoint("BOTTOM", frame, "BOTTOM", 0, 2)
		NoMountEditBox.textArea:EnableMouse(false)
		NoMountEditBox.textArea:SetTextColor(.5, .5, .5, 1)
	frame.NoMountEditBox = NoMountEditBox

	MNT4.MacroFrame = frame
	
	local DropdownMacroType -- store type here so we can reuse the dropdown generator for all 3 types
	local DropdownButton -- store our button we clicked here
	
	-- create our little Mount Type dropdown menu
	local MacroSelectDropDownMenu = CreateFrame("Frame", "MountedMacroSelectDropDownMenu")

	local function MacroSelect(dropdownbutton, arg1)
		MNT4.db.profile.macros[DropdownMacroType] = arg1
		MNT4:UpdateMacroFrame()
		MNT4:UpdateMacro()
	end

	local function NewMacroSelect(dropdownbutton, arg1)
		MNT4.MacroEditorType = DropdownMacroType
		MNT4:OpenMacroEditor()
	end

	local info = {}
	MacroSelectDropDownMenu.initialize = function(self, level)
	    if not level then return end
		wipe(info)
		if level == 1 then
			local list = {}
			for t in pairs(MNT4.db.global.macros[DropdownMacroType]) do
				list[#list+1] = t
			end
			table.sort(list, function(a,b) return a > b end)
			
			info.text = GREEN_FONT_COLOR_CODE.."New Macro"
			info.arg1 = "New Macro"
			info.checked = false
			info.func = NewMacroSelect
			UIDropDownMenu_AddButton(info, level)

			for i, t in ipairs(list) do
				info.text = t
				info.arg1 = t
				info.checked = DropdownButton:GetText() == t
				info.func = MacroSelect
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	local function dropdownOnClick(self, ...)
		DropdownMacroType = self:GetParent().__Type
		DropdownButton = self:GetParent()
		ToggleDropDownMenu(1, nil, MacroSelectDropDownMenu, self:GetParent(), 0, 0)
	end
	
	TwoMountDropdown.dropButton:SetScript("OnClick", dropdownOnClick)
	OneMountDropdown.dropButton:SetScript("OnClick", dropdownOnClick)
	NoMountDropdown.dropButton:SetScript("OnClick", dropdownOnClick)
	
	
	local function editOnClick(editbutton, arg1)
		MNT4.MacroEditorType = editbutton.__Type
		MNT4:OpenMacroEditor(true)
	end
	
	TwoMountEditButton:SetScript("OnClick", editOnClick)
	OneMountEditButton:SetScript("OnClick", editOnClick)
	NoMountEditButton:SetScript("OnClick", editOnClick)
	
	
	
	MNT4:UpdateMacroFrame()
	--MNT4:UpdateScriptState()
end

local function listbuttonClick(widget, button)
	print(widget:GetText())
end

function MNT4:UpdateMacroFrame()
	self.MacroFrame.TwoMountDropdown:SetText(self.db.profile.macros.TwoMounts)
	self.MacroFrame.TwoMountEditBox:SetText(self.db.global.macros.TwoMounts[self.db.profile.macros.TwoMounts])
	self.MacroFrame.OneMountDropdown:SetText(self.db.profile.macros.OneMount)
	self.MacroFrame.OneMountEditBox:SetText(self.db.global.macros.OneMount[self.db.profile.macros.OneMount])
	self.MacroFrame.NoMountDropdown:SetText(self.db.profile.macros.NoMounts)
	self.MacroFrame.NoMountEditBox:SetText(self.db.global.macros.NoMounts[self.db.profile.macros.NoMounts])
end

