local _, MNT4 = ...



local function LoadFrames()

MNT4.MainFrame = {}
function MNT4.MainFrame:IsVisible()
	return false
end
function MNT4.MainFrame:Show()

	local tabinfo = {
		[1] = {
				['name'] = "Mount Priority",
				['frame'] = "MountPriorityFrame",
				['icon'] = "Interface\\ICONS\\ABILITY_MOUNT_DREADSTEED",
			},
		[2] = {
				['name'] = "Mount Grouping",
				['frame'] = "MountGroupingFrame",
				['icon'] = "Interface\\ICONS\\ABILITY_HUNTER_BESTIALDISCIPLINE",
			},
		[3] = {
				['name'] = "Macros",
				['frame'] = "MacroFrame",
				['icon'] = "Interface\\ICONS\\INV_Misc_Note_04",
			},
		[4] = {
				['name'] = "Settings & Profiles",
				['frame'] = "ProfilesFrame",
				['icon'] = "Interface\\ICONS\\Achievement_BG_win_WSG_X_times",
			},

	}

	local frame = CreateFrame("Frame", "Mounted4MainFrame", PetJournalParent)
		frame:SetWidth(400)
		frame:SetHeight(605)
		frame:SetPoint("LEFT", PetJournalParent, "RIGHT", -16, 0)
		--frame:SetPoint("LEFT", SpellBookFrame, "RIGHT", 16, 0)
		frame:SetFrameLevel(0)
	
	frame._SetFrameLevel = frame.SetFrameLevel
	frame.SetFrameLevel = function(f, l)
		error("Something that was not supposed to tried to change the Mounted Frames level to level "..l)
	end

	-- Background
	local Bg = frame:CreateTexture(nil, "BACKGROUND")
		Bg:SetTexture([[Interface\FrameGeneral\UI-Background-Rock]], true)
		Bg:SetHorizTile(true)
		Bg:SetVertTile(true)
		Bg:SetPoint("TOPLEFT", 2, -21)
		Bg:SetPoint("BOTTOMRIGHT", -2, 2)

	local TitleBg = frame:CreateTexture(nil, "BACKGROUND")
		TitleBg:SetTexture([[Interface\FrameGeneral\_UI-Frame]], true)
		TitleBg:SetTexCoord(0.00000000,1.00000000,0.28906250,0.42187500)
		TitleBg:SetHorizTile(true)
		TitleBg:SetWidth(256)
		TitleBg:SetHeight(17)
		TitleBg:SetPoint("TOPLEFT", 2, -3)
		TitleBg:SetPoint("TOPRIGHT", -25, -3)

	-- Corners
	local TopLeft = frame:CreateTexture(nil, "BORDER")
		TopLeft:SetTexture([[Interface\FrameGeneral\UI-Frame]])
		TopLeft:SetTexCoord(0.63281250,0.88281250,0.28125000,0.53125000)
		TopLeft:SetWidth(32)
		TopLeft:SetHeight(32)
		TopLeft:SetPoint("TOPLEFT", -6, 1)

	local TopRight = frame:CreateTexture(nil, "BORDER")
		TopRight:SetTexture([[Interface\FrameGeneral\UI-Frame]])
		TopRight:SetTexCoord(0.63281250,0.89062500,0.00781250,0.26562500)
		TopRight:SetWidth(33)
		TopRight:SetHeight(33)
		TopRight:SetPoint("TOPRIGHT", 0, 1)

	local BotLeft = frame:CreateTexture(nil, "BORDER")
		BotLeft:SetTexture([[Interface\FrameGeneral\UI-Frame]])
		BotLeft:SetTexCoord(0.00781250,0.11718750,0.63281250,0.74218750)
		BotLeft:SetWidth(14)
		BotLeft:SetHeight(14)
		BotLeft:SetPoint("BOTTOMLEFT", -6, -5)

	local BotRight = frame:CreateTexture(nil, "BORDER")
		BotRight:SetTexture([[Interface\FrameGeneral\UI-Frame]])
		BotRight:SetTexCoord(0.13281250,0.21875000,0.89843750,0.98437500)
		BotRight:SetWidth(11)
		BotRight:SetHeight(11)
		BotRight:SetPoint("BOTTOMRIGHT", 0, -5)

	-- Middle sections
	local TopMiddle = frame:CreateTexture(nil, "BORDER")
		TopMiddle:SetTexture([[Interface\FrameGeneral\_UI-Frame]], true)
		TopMiddle:SetHorizTile(true)
		TopMiddle:SetTexCoord(0.00000000,1.00000000,0.43750000,0.65625000)
		TopMiddle:SetWidth(256)
		TopMiddle:SetHeight(28)
		TopMiddle:SetPoint("TOPLEFT", TopLeft, "TOPRIGHT")
		TopMiddle:SetPoint("TOPRIGHT", TopRight, "TOPLEFT")

	local BotMiddle = frame:CreateTexture(nil, "BORDER")
		BotMiddle:SetTexture([[Interface\FrameGeneral\_UI-Frame]], true)
		BotMiddle:SetHorizTile(true)
		BotMiddle:SetTexCoord(0.00000000,1.00000000,0.20312500,0.27343750)
		BotMiddle:SetWidth(256)
		BotMiddle:SetHeight(9)
		BotMiddle:SetPoint("BOTTOMLEFT", BotLeft, "BOTTOMRIGHT")
		BotMiddle:SetPoint("BOTTOMRIGHT", BotRight, "BOTTOMLEFT")

	local LeftMiddle = frame:CreateTexture(nil, "BORDER")
		LeftMiddle:SetTexture([[Interface\FrameGeneral\!UI-Frame]], true)
		LeftMiddle:SetVertTile(true)
		LeftMiddle:SetTexCoord(0.35937500,0.60937500,0.00000000,1.00000000)
		LeftMiddle:SetWidth(16)
		LeftMiddle:SetHeight(256)
		LeftMiddle:SetPoint("TOPLEFT", TopLeft, "BOTTOMLEFT")
		LeftMiddle:SetPoint("BOTTOMLEFT", BotLeft, "TOPLEFT")

	local RightMiddle = frame:CreateTexture(nil, "BORDER")
		RightMiddle:SetTexture([[Interface\FrameGeneral\!UI-Frame]], true)
		RightMiddle:SetVertTile(true)
		RightMiddle:SetTexCoord(0.17187500,0.32812500,0.00000000,1.00000000)
		RightMiddle:SetWidth(10)
		RightMiddle:SetHeight(256)
		RightMiddle:SetPoint("TOPRIGHT", TopRight, "BOTTOMRIGHT", 1, 0)
		RightMiddle:SetPoint("BOTTOMRIGHT", BotRight, "TOPRIGHT")


	local close = CreateFrame("Button", nil, frame)
		close:SetNormalTexture([[Interface\Buttons\UI-SpellbookIcon-PrevPage-Up]])
		close:SetPushedTexture([[Interface\Buttons\UI-SpellbookIcon-PrevPage-Down]])
		close:SetDisabledTexture([[Interface\Buttons\UI-SpellbookIcon-PrevPage-Disabled]])
		close:SetHighlightTexture([[Interface\Buttons\UI-Common-MouseHilight]], "ADD")
		close:SetWidth(32)
		close:SetHeight(32)
		close:SetPoint("TOPRIGHT", 4, 5)
		close:SetScript("OnClick", function()
			PlaySoundFile("Sound\\Doodad\\Karazahn_WoodenDoors_Close_A.wav")
			close.Ani._xOffset = 16+24-frame:GetWidth()
			close.Ani:SetOffset(close.Ani._xOffset*frame:GetEffectiveScale(), 0)
			frame.childframe.FadeOutGroup:Play()
		end)

	local open = CreateFrame("Button", nil, frame)
		open:SetNormalTexture([[Interface\Buttons\UI-SpellbookIcon-NextPage-Up]])
		open:SetPushedTexture([[Interface\Buttons\UI-SpellbookIcon-NextPage-Down]])
		open:SetDisabledTexture([[Interface\Buttons\UI-SpellbookIcon-NextPage-Disabled]])
		open:SetHighlightTexture([[Interface\Buttons\UI-Common-MouseHilight]], "ADD")
		open:SetWidth(32)
		open:SetHeight(32)
		open:SetPoint("TOPRIGHT", 4, 5)
		open:SetScript("OnClick", function()
			PlaySoundFile("Sound\\Doodad\\Karazahn_WoodenDoors_Close_A.wav")
			open.Ani._xOffset = frame:GetWidth()-16-24
			open.Ani:SetOffset(open.Ani._xOffset*frame:GetEffectiveScale(), 0)
			open.AniGroup:Play()
		end)
		open:Hide()

		-- close animation
		close.AniGroup = frame:CreateAnimationGroup()
			close.Ani = close.AniGroup:CreateAnimation("Translation")
				close.Ani:SetOffset(320, 0)
				close.Ani:SetDuration(1.25)
				close.Ani:SetOrder(1)
				close.Ani:SetSmoothing("IN_OUT")
				close.Ani:SetScript("OnFinished", function(self)
					frame:SetPoint("LEFT", PetJournalParent, "RIGHT", -16+self._xOffset, 0)
					close:Hide()
					open:Show()
				end)
		-- open animation
		open.AniGroup = frame:CreateAnimationGroup()
			open.Ani = open.AniGroup:CreateAnimation("Translation")
				open.Ani:SetOffset(320, 0)
				open.Ani:SetDuration(1.5)
				open.Ani:SetOrder(1)
				open.Ani:SetSmoothing("IN_OUT")
				open.Ani:SetScript("OnFinished", function(self)
					frame:SetPoint("LEFT", PetJournalParent, "RIGHT", -16, 0)
					open:Hide()
					close:Show()

					frame.childframe:Show()
					frame.childframe.FadeInGroup:Play()
				end)

		local titleText = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
			titleText:SetPoint("TOP", 0 , -4)
			titleText:SetText("Mounted")

		-- FadeIn animation
		frame.FadeInGroup = frame:CreateAnimationGroup()
			frame.FadeIn = frame.FadeInGroup:CreateAnimation("Animation") -- alpha is bugged when fading it it reverts to the original alpha when finished
				frame.FadeIn:SetDuration(.25)
				frame.FadeIn:SetOrder(1)
				frame.FadeIn:SetSmoothing("IN_OUT")
				frame.FadeIn:SetScript("OnPlay", function(self)
					frame:SetAlpha(0)
				end)
				frame.FadeIn:SetScript("OnUpdate", function(self)
					frame:SetAlpha(self:GetSmoothProgress())
				end)
				frame.FadeIn:SetScript("OnFinished", function(self)
					frame:SetAlpha(1)
				end)

		-- FadeOut animation
		frame.FadeOutGroup = frame:CreateAnimationGroup()
			frame.FadeOut = frame.FadeOutGroup:CreateAnimation("Alpha")
				frame.FadeOut:SetChange(-1)
				frame.FadeOut:SetDuration(.25)
				frame.FadeOut:SetOrder(1)
				frame.FadeOut:SetSmoothing("IN_OUT")
				frame.FadeOut:SetScript("OnPlay", function(self)
					frame:SetAlpha(1)
				end)
				frame.FadeOut:SetScript("OnFinished", function(self)
					frame:SetAlpha(0)
					frame:Hide()
				end)

	local childframe = CreateFrame("Frame", nil, frame)
		childframe:SetPoint("TOPLEFT", frame, "TOPLEFT", 18, -22)
		childframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -6, 6)
		childframe:SetFrameLevel(1)

		-- FadeIn animation
		childframe.FadeInGroup = childframe:CreateAnimationGroup()
			childframe.FadeIn = childframe.FadeInGroup:CreateAnimation("Animation") -- alpha is bugged when fading it it reverts to the original alpha when finished
				childframe.FadeIn:SetDuration(.25)
				childframe.FadeIn:SetOrder(1)
				--childframe.FadeIn:SetSmoothing("IN_OUT")
				childframe.FadeIn:SetScript("OnPlay", function(self)
					childframe:SetAlpha(0)
				end)
				childframe.FadeIn:SetScript("OnUpdate", function(self)
					childframe:SetAlpha(self:GetSmoothProgress())
				end)
				childframe.FadeIn:SetScript("OnFinished", function(self)
					childframe:SetAlpha(1)
				end)

		-- FadeOut animation
		childframe.FadeOutGroup = childframe:CreateAnimationGroup()
			childframe.FadeOut = childframe.FadeOutGroup:CreateAnimation("Alpha")
				childframe.FadeOut:SetChange(-1)
				childframe.FadeOut:SetDuration(.25)
				childframe.FadeOut:SetOrder(1)
				--childframe.FadeOut:SetSmoothing("IN_OUT")
				childframe.FadeOut:SetScript("OnPlay", function(self)
					childframe:SetAlpha(1)
				end)
				childframe.FadeOut:SetScript("OnFinished", function(self)
					childframe:SetAlpha(0)
					childframe:Hide()
					close.AniGroup:Play()
				end)

	frame.childframe = childframe

	local tabs = {}

	local function OnClick(self)
		local id = self:GetID()
		for i, tab in ipairs(tabs) do
			if i ~= id then
				tab:SetChecked(false)
			else
				tab:SetChecked(true)
			end
		end
		if childframe.child then
			childframe.child:ClearAllPoints()
			childframe.child:Hide()
			childframe.child = nil
		end
		MNT4[tabinfo[id].frame]:Show()
		childframe.child = MNT4[tabinfo[id].frame]
		childframe.child:SetParent(childframe)
		childframe.child:SetFrameLevel(2)
		childframe.child:SetAllPoints(childframe)
	end

	for i , t in ipairs(tabinfo) do
		tabs[i] = MNT4:GetWidget("SideIconTab", childframe)
		tabs[i]:SetNormalTexture(t.icon)
		tabs[i]:SetScript("OnClick", OnClick)
		tabs[i].tooltip = t.name
		tabs[i]:SetID(i)
		if i == 1 then
			tabs[i]:SetPoint("TOPLEFT", childframe, "TOPRIGHT", 7, -15)
		else
			tabs[i]:SetPoint("TOPLEFT", tabs[i-1], "BOTTOMLEFT", 0, -17)
		end
	end

	OnClick(tabs[1])

	if MNT4.db.profile.startMinimized then
		frame:SetPoint("LEFT", PetJournalParent, "RIGHT", -16+(16+24-frame:GetWidth()), 0)
		close:Hide()
		open:Show()
		childframe:SetAlpha(0)
		childframe:Hide()
	end

	MNT4.MainFrame = frame
end

hooksecurefunc(MountJournal, "Show", function(self, MountJournal)
	if not MNT4.MainFrame:IsVisible() then
		MNT4.MainFrame:Show()
		MNT4.MainFrame.FadeOutGroup:Stop()
		--MNT4.MainFrame:SetAlpha(.25)
		MNT4.MainFrame.FadeInGroup:Play()
		--Spew("fadein", MNT4.MainFrame.FadeIn)
	end
	-- fix levels since other addons insist on screwing with them sigh
	MNT4.MainFrame:_SetFrameLevel(0)
	MNT4.MainFrame.childframe:SetFrameLevel(1)
	MNT4.MainFrame.childframe.child:SetFrameLevel(2)
end)
hooksecurefunc(MountJournal, "Hide", function(self, MountJournal)
	MNT4.MainFrame.FadeInGroup:Stop()
	MNT4.MainFrame:SetAlpha(1)
	MNT4.MainFrame.FadeOutGroup:Play()
	wipe(MNT4.wr_blacklist) -- reset blacklists when settings close and update the macro
	wipe(MNT4.wr_reverseblacklist)
	MNT4:UpdateMacro()
end)

hooksecurefunc(PetJournalParent, "Hide", function(self)
	if MNT4.MainFrame.Hide then
		MNT4.MainFrame:Hide()
	end
	wipe(MNT4.wr_blacklist) -- reset blacklists when settings close and update the macro
	wipe(MNT4.wr_reverseblacklist)
	MNT4:UpdateMacro()
end)





end

if not PetJournalParent then
	local eventframe = CreateFrame('frame')
	eventframe:SetScript("OnEvent", function(self, event, ...) if eventframe[event] then return eventframe[event](eventframe, event, ...) end end)
	eventframe:RegisterEvent("ADDON_LOADED")
	function eventframe:ADDON_LOADED(event, addon)
		if PetJournalParent then
			self:UnregisterEvent("ADDON_LOADED")
			self.ADDON_LOADED = nil
			LoadFrames()
		end
	end
else
	LoadFrames()
end