local _, MNT4 = ...

MNT4.MountGroupEditorFrame = {}
function MNT4.MountGroupEditorFrame:IsVisible()
	return false
end
function MNT4.MountGroupEditorFrame:Show()
	local frame = MNT4:GetWidget("frame", UIParent)
		frame:SetPoint("CENTER")
		frame:SetWidth(550)
		frame:SetHeight(400)
		frame:SetText("Mounted Group Editor")

	local SAVEbutton = MNT4:GetWidget("button", frame)
		SAVEbutton:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 13, 13)
		SAVEbutton:SetWidth((frame:GetWidth()-26)/3)
		SAVEbutton:SetText(SAVE)
	frame.SAVEbutton = SAVEbutton

	local DELETEbutton = MNT4:GetWidget("button", frame)
		DELETEbutton:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -13, 13)
		DELETEbutton:SetWidth((frame:GetWidth()-26)/3)
		DELETEbutton:SetText(DELETE)
	frame.DELETEbutton = DELETEbutton

	local CANCELbutton = MNT4:GetWidget("button", frame)
		CANCELbutton:SetPoint("BOTTOMRIGHT", DELETEbutton, "BOTTOMLEFT")
		CANCELbutton:SetPoint("BOTTOMLEFT", SAVEbutton, "BOTTOMRIGHT")
		CANCELbutton:SetText(CANCEL)
	frame.CANCELbutton = CANCELbutton

	local nametitle = MNT4:GetWidget("title", frame)
		nametitle:SetPoint("TOPLEFT", frame, "TOPLEFT", 13, -20)
		nametitle:SetPoint("RIGHT", frame, "RIGHT", -13, 0)
		nametitle:SetText("Mount Group Name")
	frame.nametitle = nametitle

	local name = MNT4:GetWidget("editbox", frame)
		name:SetPoint("TOPLEFT", nametitle, "BOTTOMLEFT", 0,-1)
		name:SetPoint("TOPRIGHT", nametitle, "BOTTOMRIGHT", 0,-1)
	frame.name = name


	local scrollframe = MNT4:GetWidget("scrollframe", frame)
		scrollframe:SetPoint("TOPLEFT", name, "BOTTOMLEFT", 0,-2)
		scrollframe:SetPoint("BOTTOMRIGHT", DELETEbutton, "TOPRIGHT")
	frame.scrollframe = scrollframe


	name.textArea:SetScript("OnTextChanged", function()
		if name:GetText():len() > 0 then
			SAVEbutton:Enable()
		else
			SAVEbutton:Disable()
		end
	end)

	CANCELbutton:SetScript("OnClick", function(self, button)
		MNT4.MountGroupEditorFrame:Hide()
	end)

	SAVEbutton:SetScript("OnClick", function(self, button)
		local group = {}
		local groupname = frame.name:GetText()
		local mountType = MNT4.MountGroupingFrameStateType
		for i, widget in ipairs(frame.__widgetlist) do
			if widget:GetChecked() then
				MNT4.db.profile.mounts.types[mountType][widget.__mount] = groupname
				group[widget.__mount] = true
				for k in pairs(MNT4.db.profile.mountsets) do
					MNT4.db.profile.mountsets[k][mountType][widget.__mount] = nil
				end
			else
				if MNT4.db.profile.mounts.types[mountType][widget.__mount] == groupname then
					MNT4.db.profile.mounts.types[mountType][widget.__mount] = true
					for k in pairs(MNT4.db.profile.mountsets) do
						MNT4.db.profile.mountsets[k][mountType][widget.__mount] = MNT4.db.profile.mountsets[k][mountType][groupname] or 50
					end
				end
			end
		end
		if next(group) then
			for k in pairs(MNT4.db.profile.mountsets) do
				MNT4.db.profile.mountsets[k][mountType][groupname] = MNT4.db.profile.mountsets[k][mountType][groupname] or 50
			end
			MNT4.db.profile.mounts.groups[mountType][groupname] = group
			MNT4.MountGroupEditorFrame:Hide()
			MNT4:UpdateMountGroupingFrame()
		else
			print('no mounts selected')
		end
	end)

	DELETEbutton:SetScript("OnClick", function(self, button)
		local groupname = frame.name:GetText()
		local mountType = MNT4.MountGroupingFrameStateType
		for mount in pairs(MNT4.db.profile.mounts.groups[mountType][groupname]) do
			MNT4.db.profile.mounts.types[mountType][mount] = true
			for k in pairs(MNT4.db.profile.mountsets) do
				MNT4.db.profile.mountsets[k][mountType][mount] = MNT4.db.profile.mountsets[k][mountType][groupname]
			end
		end
		for k in pairs(MNT4.db.profile.mountsets) do
			MNT4.db.profile.mountsets[k][mountType][groupname] = nil
		end
		MNT4.db.profile.mounts.groups[mountType][groupname] = nil
		MNT4.MountGroupEditorFrame:Hide()
		MNT4:UpdateMountGroupingFrame()
	end)

	MNT4.MountGroupEditorFrame = frame
end

function MNT4:OpenMountGroupEditor(groupname)
	local mountType = MNT4.MountGroupingFrameStateType
	self.MountGroupEditorFrame:Show()
	local frame = self.MountGroupEditorFrame
	if groupname then
		frame.name:Disable()
		frame.nametitle:Disable()
		frame.DELETEbutton:Enable()
	else
		frame.name:Enable()
		frame.nametitle:Enable()
		frame.DELETEbutton:Disable()
	end
	frame.__name = groupname or ""
	frame.name:SetText(frame.__name)

	frame.__widgetlist = frame.__widgetlist or {}
	for i, widget in ipairs(frame.__widgetlist) do
		self:ReturnWidget(widget)
		frame.__widgetlist[i] = nil
	end
	local mounts = self.db.profile.mounts.types[mountType]
	local reverseGroupLookup = {}
	for gName, t in pairs(self.db.profile.mounts.groups[mountType]) do
		for id in pairs(t) do
			reverseGroupLookup[id] = gName
		end
	end

	local sortedmounts = {}
	for mount in pairs(mounts) do
		sortedmounts[#sortedmounts+1] = mount
	end
	table.sort(sortedmounts, function(a,b)
		if reverseGroupLookup[a] == reverseGroupLookup[b] then
			a = GetSpellInfo(a)
			b = GetSpellInfo(b)
			return a:lower() < b:lower()
		elseif not reverseGroupLookup[a] then
			return true
		elseif not reverseGroupLookup[b] then
			return false
		else
			return reverseGroupLookup[a]:lower() < reverseGroupLookup[b]:lower()
		end
	end)

	local widgets = 0
	local columns = 2
	local child = frame.scrollframe.child
	local width = (550-55)/columns

	for i, mount in ipairs(sortedmounts) do
		local checkbox = MNT4:GetWidget("checkbox", child)
			checkbox:SetWidth(width)
			checkbox:SetText(GetSpellInfo(mount))
			checkbox.__mount = mount
			local modu = widgets%columns
			local top = checkbox:GetHeight() * ((widgets-modu)/columns)
			checkbox:SetPoint("TOPLEFT", child, "TOPLEFT", modu*width, -1*top)
			local mountname = GetSpellInfo(mount)
			if reverseGroupLookup[mount] == frame.__name then
				checkbox:SetChecked(true)
				checkbox:SetText(ORANGE_FONT_COLOR_CODE.."("..reverseGroupLookup[mount]..") "..FONT_COLOR_CODE_CLOSE..mountname)
			elseif reverseGroupLookup[mount] then
				checkbox:Disable()
				checkbox:SetText(ORANGE_FONT_COLOR_CODE.."("..reverseGroupLookup[mount]..") "..FONT_COLOR_CODE_CLOSE..mountname)
			else
				checkbox:SetText(mountname)
			end
			checkbox:Show()
		frame.__widgetlist[#frame.__widgetlist+1] = checkbox
		child:SetHeight(checkbox:GetHeight() * (((widgets-modu)/columns)+1))
		widgets = i
	end


end

