local _, MNT4 = ...


MNT4.MountPriorityFrame = {}
function MNT4.MountPriorityFrame:Show()
	local frame = CreateFrame("frame", nil, UIParent)
		frame:SetPoint("CENTER")
		frame:SetWidth(300)
		frame:SetHeight(400)
		frame:Show()

	local settitle = MNT4:GetWidget("title", frame)
		settitle:SetPoint("TOPLEFT", frame, "TOPLEFT", 2, -2)
		settitle:SetPoint("RIGHT", frame, "CENTER", -2, 0)
		settitle:SetText("Mount Priority Sets")
	frame.settitle = settitle

	local newSetdropdown = MNT4:GetWidget("dropdownbutton", frame)
		newSetdropdown:SetPoint("TOP", settitle, "TOP", 0, -2)
		newSetdropdown:SetPoint("RIGHT", frame, "RIGHT", -2, 0)
		newSetdropdown:SetPoint("LEFT", settitle, "RIGHT", 4, 0)
		newSetdropdown:SetText("New Set")
	frame.newSetdropdown = newSetdropdown

	local setscrollframe = MNT4:GetWidget("scrollframe", frame)
		setscrollframe:SetPoint("TOPLEFT", settitle, "BOTTOMLEFT", 0,-2)
		setscrollframe:SetPoint("RIGHT", newSetdropdown, "RIGHT", 0, 0)
		setscrollframe:SetPoint("BOTTOM", frame, "CENTER", 0,75)
	frame.setscrollframe = setscrollframe

	local typetitle = MNT4:GetWidget("title", frame)
		typetitle:SetPoint("TOPLEFT", setscrollframe, "BOTTOMLEFT", 0, 0)
		typetitle:SetPoint("RIGHT", setscrollframe, "CENTER", 0,-2)
		typetitle:SetText("Mount Type Priorities")
	frame.typetitle = typetitle

	local typedropdown = MNT4:GetWidget("dropdownbutton", frame)
		typedropdown:SetPoint("TOPRIGHT", setscrollframe, "BOTTOMRIGHT", 0,-4)
		typedropdown:SetPoint("LEFT", setscrollframe, "CENTER", 0,2)
		typedropdown:SetText("ground")
	frame.typedropdown = typedropdown


	local scrollframe = MNT4:GetWidget("scrollframe", frame)
		scrollframe:SetPoint("TOPLEFT", typetitle, "BOTTOMLEFT", 0,-2)
		scrollframe:SetPoint("RIGHT", typedropdown, "RIGHT", 0, 0)
		scrollframe:SetPoint("BOTTOM", frame, "BOTTOM", 0,2)
	frame.scrollframe = scrollframe

	-- create our little Mount Set dropdown menu
	local MountSetDropDownMenu = CreateFrame("Frame", "MountedMountSetDropDownMenu")

	local function GetDeepCopyTable(orig)
		local new = {}
		for k, v in pairs(orig) do
			if type(v) == 'table' then
				new[k] = GetDeepCopyTable(v)
			else
				new[k] = v
			end
		end
		return new
	end

	local popupVAR
	StaticPopupDialogs["MountedAskToCopySet"] = {
		text = "Do you want to copy priorities from the default set?",
		button1 = "Yes",
		button2 = "No",
		button3 = "Cancel",
		OnAccept = function()
			table.insert(MNT4.db.profile.mountsetpriorities, 2, popupVAR)
			MNT4.db.profile.mountsets[popupVAR] = GetDeepCopyTable(MNT4.db.profile.mountsets.default)

			MNT4:UpdateMountPriorityFrame()
			MNT4:UpdateState()
		end,
		OnCancel = function()
			table.insert(MNT4.db.profile.mountsetpriorities, 2, popupVAR)
			MNT4.db.profile.mountsets[popupVAR] = {}
			local set = MNT4.db.profile.mountsets[popupVAR]
			for cat, t in pairs(MNT4.db.profile.mountsets.default) do
				set[cat] = {}
				for id in pairs(t) do
					set[cat][id] = 50
				end
			end

			MNT4:UpdateMountPriorityFrame()
			MNT4:UpdateState()
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}

	StaticPopupDialogs["MountedOtherSet"] = {
		text = "Enter a zone name you want a separate mount priority set for. |n "..RED_FONT_COLOR_CODE.."Input is not validated and the set may never activate if no such zone exists.",
		button1 = "OK",
		button2 = "Cancel",
		hasEditBox = true,
		OnAccept = function(self)
			popupVAR = self.editBox:GetText()
			StaticPopup_Show("MountedAskToCopySet")
		end,
		OnShow = function (self, data)
			self.button1:Disable()
		end,
		EditBoxOnTextChanged = function (self, data)
			self:GetParent().button1:Enable()
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}

	local function MountSetDropdownSelect(dropdownbutton, arg1)
		CloseDropDownMenus()
		if arg1 == "Other Zone" then
			StaticPopup_Show("MountedOtherSet")
		else
			popupVAR = arg1
			StaticPopup_Show("MountedAskToCopySet")
		end
	end

	local info = {}
	MountSetDropDownMenu.initialize = function(self, level)
	    if not level then return end
		wipe(info)
		if level == 1 then
			local list = {GetMapContinents()}

			for i, t in ipairs(list) do
				info.text = t
				info.hasArrow = true
				info.value = i
				info.notCheckable = true
				UIDropDownMenu_AddButton(info, level)
			end

			-- add Other Category
			info.text = YELLOW_FONT_COLOR_CODE.."Other"
			info.hasArrow = true
			info.value = "Other"
			info.notCheckable = true
			UIDropDownMenu_AddButton(info, level)
		elseif level == 2 then
			if UIDROPDOWNMENU_MENU_VALUE == "Other" then
				local list = {
					[1] = "pvp",
					[2] = "instance",
					[3] = "group",
					[4] = "Other Zone",
				}
				for i, t in ipairs(list) do
					if not MNT4.db.profile.mountsets[t] then
						info.text = t
						info.arg1 = t
						info.func = MountSetDropdownSelect
						info.notCheckable = true
						UIDropDownMenu_AddButton(info, level)
					end
				end
			else
				local list = {GetMapZones(UIDROPDOWNMENU_MENU_VALUE)}
				for i, t in ipairs(list) do
					if not MNT4.db.profile.mountsets[t] then
						info.text = t
						info.arg1 = t
						info.func = MountSetDropdownSelect
						info.notCheckable = true
						UIDropDownMenu_AddButton(info, level)
					end
				end
			end
		end
	end

	newSetdropdown.dropButton:SetScript("OnClick", function(self, button, down)
		ToggleDropDownMenu(1, nil, MountSetDropDownMenu, newSetdropdown, 0, 0)
	end)

	-- create our little Mount Type dropdown menu
	local MountTypeDropDownMenu = CreateFrame("Frame", "MountedMountTypeDropDownMenu")

	local function typeSelect(dropdownbutton, arg1)
		typedropdown:SetText(arg1)
		MNT4.MountPriorityFrameStateType = arg1
		MNT4:UpdateMountPriorityFrame()
	end

	local info = {}
	MountTypeDropDownMenu.initialize = function(self, level)
	    if not level then return end
		wipe(info)

		if level == 1 then
			local list = {}
			for t in pairs(MNT4.db.profile.mounts.types) do
				list[#list+1] = t
			end
			table.sort(list, function(a,b) return a > b end)
			
			for i, t in ipairs(list) do
				info.text = t
				info.arg1 = t
				info.checked = typedropdown:GetText() == t
				info.func = typeSelect
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end

	typedropdown.dropButton:SetScript("OnClick", function(self, button, down)
		ToggleDropDownMenu(1, nil, MountTypeDropDownMenu, typedropdown, 0, 0)
	end)

	frame:SetScript("OnShow", function() MNT4:UpdateMountPriorityFrame() end)

	MNT4.MountPriorityFrame = frame
	MNT4.MountPriorityFrameStateSet = 'default' -- store which mountset we are looking at
	MNT4.MountPriorityFrameStateType = 'ground' -- store type of mounts we are looking at
	--MNT4:UpdateMountPriorityFrame()
end

local function prioritylistbuttonClick(widget, button)
	MNT4:OpenMountGroupEditor(widget._mount)
end

local function setlistbuttonClick(widget, button)
	MNT4.MountPriorityFrameStateSet = widget._SetName
	MNT4:UpdateMountPriorityFrame()
end

local function setlistUP(widget, button)
	local position = widget:GetParent()._SetPos
	local name = widget:GetParent()._SetName
	table.remove(MNT4.db.profile.mountsetpriorities, position) -- remove from table
	table.insert(MNT4.db.profile.mountsetpriorities, position+1, name) -- add in new location
	MNT4:UpdateMountPriorityFrame()
	MNT4:UpdateState()
end

local function setlistDOWN(widget, button)
	local position = widget:GetParent()._SetPos
	local name = widget:GetParent()._SetName
	table.remove(MNT4.db.profile.mountsetpriorities, position) -- remove from table
	table.insert(MNT4.db.profile.mountsetpriorities, position-1, name) -- add in new location
	MNT4:UpdateMountPriorityFrame()
	MNT4:UpdateState()
end

local function setlistDEL(widget, button)
	local position = widget:GetParent()._SetPos
	local name = widget:GetParent()._SetName
	table.remove(MNT4.db.profile.mountsetpriorities, position) -- remove from table
	MNT4.db.profile.mountsets[name] = nil -- remove the mount set priorities
	MNT4:UpdateMountPriorityFrame()
	MNT4:UpdateState()
end

function MNT4:UpdateMountPriorityFrame()
	self.MountPriorityFrame:Show()
	local frame = self.MountPriorityFrame
	if not self.db.profile.mountsets[self.MountPriorityFrameStateSet] then
		self.MountPriorityFrameStateSet = 'default'
	end
	do -- priority sets stuff
		local child = frame.setscrollframe.child
		self.MountSetPriorityLines = self.MountSetPriorityLines or {}
		local lines = self.MountSetPriorityLines
		for i, w in pairs(lines) do
			if w.sep then
				w.sep = self:ReturnWidget(w.sep)
			end
			w.up:SetAlpha(1)
			w.down:SetAlpha(1)
			self:ReturnWidget(w)
			lines[i] = nil
		end
		local sets = self.db.profile.mountsetpriorities
		for i=#sets,1,-1 do
			local widget = self:GetWidget("UpDownDeleteButton", child)
			widget:Enable()
			if next(lines) then
				widget.sep = self:GetWidget("HorizontalSeparator", child)
				widget.sep:SetPoint("TOPLEFT", lines[#lines], "BOTTOMLEFT", 0, 0)
				widget.sep:SetPoint("TOPRIGHT", lines[#lines], "BOTTOMRIGHT", 0, 0)
				widget.sep:Show()
				widget:SetPoint("TOPLEFT", widget.sep, "BOTTOMLEFT", 0, 0)
				widget:SetPoint("TOPRIGHT", widget.sep, "BOTTOMRIGHT", 0, 0)
			else
				widget:SetPoint("TOPLEFT", child, "TOPLEFT", 0, 0)
				widget:SetPoint("TOPRIGHT", child, "TOPRIGHT", 0, 0)
			end
			--G_blist[sets[i]] = true
			widget:SetText(sets[i])
			widget._SetName = sets[i]
			widget._SetPos = i
			if sets[i] == self.MountPriorityFrameStateSet then
				widget.check:Show()
			end
			widget:SetScript("OnClick", setlistbuttonClick)
			widget.up:SetScript("OnClick", setlistUP)
			widget.down:SetScript("OnClick", setlistDOWN)
			widget.del:SetScript("OnClick", setlistDEL)
			widget:Show()
			lines[#lines+1] =  widget
			child:SetHeight(#lines*widget:GetHeight())
		end

		-- disable last line its the default set which should always be least important
		lines[#lines].up:Disable()
		lines[#lines].down:Disable()
		lines[#lines].del:Disable()
		if #lines > 1 then
			-- disable topmost up button
			lines[1].up:Disable()
			-- disable second to bottom down button
			lines[#lines-1].down:Disable()
		end
	end
	do -- priorities stuff
		frame.typedropdown:SetText(self.MountPriorityFrameStateType)

		--frame.scrollframe.scroll:SetVerticalScroll(0)
		frame.scrollframe.scrollbar:SetValue(0)
		local child = frame.scrollframe.child
		self.MountPriorityLines = self.MountPriorityLines or {}
		local lines = self.MountPriorityLines
		for i, w in pairs(lines) do
			if w.sep then
				w.sep = self:ReturnWidget(w.sep)
			end
			self:ReturnWidget(w)
			lines[i] = nil
		end

		local mounts = self.db.profile.mountsets[self.MountPriorityFrameStateSet][self.MountPriorityFrameStateType]
		local sortedmounts = {}
		for m in pairs(mounts) do
			sortedmounts[#sortedmounts+1] = m
		end
		table.sort(sortedmounts, function(a,b)
			if type(a) == 'number' then
				a = GetSpellInfo(a)
			end
			if type(b) == 'number' then
				b = GetSpellInfo(b)
			end

			return a:lower() < b:lower()
		end)
		for i, m in ipairs(sortedmounts) do
			local widget = self:GetWidget("MountPrioritySlider", child)
			if next(lines) then
				widget.sep = self:GetWidget("HorizontalSeparator", child)
				widget.sep:SetPoint("TOPLEFT", lines[#lines], "BOTTOMLEFT", 0, 0)
				widget.sep:SetPoint("TOPRIGHT", lines[#lines], "BOTTOMRIGHT", 0, 0)
				widget.sep:Show()
				widget:SetPoint("TOPLEFT", widget.sep, "BOTTOMLEFT", 0, 0)
				widget:SetPoint("TOPRIGHT", widget.sep, "BOTTOMRIGHT", 0, 0)
			else
				widget:SetPoint("TOPLEFT", child, "TOPLEFT", 0, 0)
				widget:SetPoint("TOPRIGHT", child, "TOPRIGHT", 0, 0)
			end
			if type(m) == 'string' then
				widget._group = true
				widget._mount = m
				widget._MountID = MNT4.spellIDtoIndex[next(self.db.profile.mounts.groups[self.MountPriorityFrameStateType][m])]
				widget:SetText(ORANGE_FONT_COLOR_CODE..m)
				widget.slider:SetValue(mounts[m])
			else
				widget._group = false
				widget._mount = m
				widget._MountID = MNT4.spellIDtoIndex[m]
				if widget._MountID then
					widget:SetText(GetSpellInfo(m))
				else
					widget:SetText(GRAY_FONT_COLOR_CODE..GetSpellInfo(m))
				end
				widget.slider:SetValue(mounts[m])
			end

			widget:Show()
			lines[#lines+1] =  widget
			child:SetHeight(#lines*widget:GetHeight())
		end
	end
end

