local _, addon = ...

addon.wr_blacklist = {}
addon.wr_reverseblacklist = {}
local tempList = {}
local tempGroupList = {}
local GroupPick = {}
function addon:GetWeightedRandom(t, mountType)
	if not next(t) then return nil end -- make sure that t is populated
	local size = 0
	addon.wr_reverseblacklist[t] = addon.wr_reverseblacklist[t] or {}
	addon.wr_blacklist[t] = addon.wr_blacklist[t] or {}
	local tableSize = 0
	for k, p in pairs(t) do
		if p > 0 then
			tableSize = tableSize + 1

			if addon.db.profile.mounts.groups[mountType][k] then
				for mnt in pairs(addon.db.profile.mounts.groups[mountType][k]) do
					tempGroupList[#tempGroupList+1] = mnt
				end
				GroupPick[k] = tempGroupList[math.random(#tempGroupList)]
				wipe(tempGroupList)
			end

			if not addon.wr_reverseblacklist[t][k] and not MNT4.unsumonable[GroupPick[k] or k] and MNT4.sumonable[GroupPick[k] or k] and IsUsableSpell(GroupPick[k] or k) then
				tempList[#tempList+1] = k
				size = size + p
			end
		end
	end
	local blacklistSize = math.floor((tableSize+2)/4) -- default blacklist size to 1 so we don't get repeats
	if blacklistSize > 5 then blacklistSize = 5 end -- set a hard limit on blacklist size so that priorities do not become irrelevant
	if #addon.wr_blacklist[t] > blacklistSize then wipe(addon.wr_blacklist[t]) end -- if our blacklist size is to big at this point our valid #t has decreased so we should simply wipe the table

	local pick
	if next(tempList) then
		local grow = 0
		local target = math.random(size)
		local counter = 0
		while (grow < target) do
			counter = counter + 1
			pick = tempList[counter]
			grow = grow + t[pick]
		end
	else
		pick = addon.wr_blacklist[t][#addon.wr_blacklist[t]]
		addon.wr_blacklist[t][#addon.wr_blacklist[t]] = nil
	end

	if not pick then -- if everything is at 0 priority we simply use next() to pick the next one (blacklist and randomness be damned)
		pick = next(t)
	end

	addon.wr_reverseblacklist[t][pick] = true
	table.insert(addon.wr_blacklist[t], 1, pick)
	while( #addon.wr_blacklist[t] > blacklistSize ) do
		addon.wr_reverseblacklist[t][table.remove(addon.wr_blacklist[t])] = nil -- remove old items from blacklist if its overflowing
	end
	pick = GroupPick[pick] or pick

	--need this last part if everything has zero priority
	wipe(tempList)
	if addon.db.profile.mounts.groups[mountType][pick] then
		for k in pairs(addon.db.profile.mounts.groups[mountType][pick]) do
			tempList[#tempList+1] = k
		end
		pick = tempList[math.random(#tempList)]
		wipe(tempList)
	end
	wipe(GroupPick)
	return pick
end

-------- Test Code ------
--[[
/script for i=1, 10000 do  print(MNT4:GetWeightedRandom(MNT4.db.profile.mountpriorities["air"])) end
/script for i=1, 10000 do  print(MNT4:GetWeightedRandom(MNT4.db.profile.mountpriorities["Vashj'ir"])) end


]]--

