local addonname, addon = ...

local function SetText(self, text)
	return self.text:SetText(text)
end
local function GetText(self)
	return self.text:GetText()
end
local function SetChecked(self, state)
	self.checked = state
	if state then
		self.check:Show()
	else
		self.check:Hide()
	end
end
local function GetChecked(self)
	return self.checked
end

local function Enable(box)
	box.text:SetTextColor(1,1,1,1)
end

local function Disable(box)
	box.text:SetTextColor(.5,.5,.5,1)
end

local function Constructor()
	local checkbox = CreateFrame("Button", nil, UIParent)
	checkbox:SetWidth(100)
	checkbox:SetHeight(24)
	checkbox:EnableMouse(true)

	local checkbg = checkbox:CreateTexture(nil, "ARTWORK")
		checkbg:SetWidth(24)
		checkbg:SetHeight(24)
		checkbg:SetPoint("TOPLEFT")
		checkbg:SetTexture("Interface\\Buttons\\UI-CheckBox-Up")
	checkbox.checkbg = checkbg

	local check = checkbox:CreateTexture(nil, "OVERLAY")
		check:SetAllPoints(checkbg)
		check:SetTexture("Interface\\Buttons\\UI-CheckBox-Check")
		check:Hide()
	checkbox.check = check
	checkbox.checked = false

	local text = checkbox:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
		text:SetJustifyH("LEFT")
		text:SetHeight(18)
		text:SetPoint("LEFT", checkbg, "RIGHT")
		text:SetPoint("RIGHT")
	checkbox.text = text

	local highlight = checkbox:CreateTexture(nil, "HIGHLIGHT")
		highlight:SetTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
		highlight:SetBlendMode("ADD")
		highlight:SetAllPoints(checkbg)
	checkbox.highlight = highlight

	checkbox.SetText = SetText
	checkbox.GetText = GetText
	checkbox.SetChecked = SetChecked
	checkbox.GetChecked = GetChecked
	checkbox:SetScript("OnClick", function(self)
		self:SetChecked(not self.checked)
	end)
	checkbox:SetScript("OnEnable", Enable)
	checkbox:SetScript("OnDisable", Disable)


	return checkbox
end

local function Neutralizer(checkbox)
	checkbox:SetParent(UIParent)
	checkbox:SetText("")
	checkbox:SetChecked(false)
	--checkbox:SetScript("OnClick", nil)
	checkbox:SetScript("OnEnter", nil)
	checkbox:SetScript("OnLeave", nil)
	checkbox:Enable()
	checkbox:Hide()
end

addon:RegisterWidget("checkbox", Constructor, Neutralizer)