local addonname, addon = ...

local backdrop = {
	bgFile = [[Interface\Tooltips\UI-Tooltip-Background]],
	edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]], edgeSize = 16,
	insets = { left = 4, right = 3, top = 4, bottom = 3 }
}

local function GetText(box)
	return box.textArea:GetText()
end

local function SetText(box, t)
	return box.textArea:SetText(t)
end

local function Enable(box)
	box.textArea:SetTextColor(1,1,1,1)
	box.textArea:EnableMouse(true)
end

local function Disable(box)
	box.textArea:SetTextColor(.5,.5,.5,1)
	box.textArea:EnableMouse(false)
	box.textArea:ClearFocus()
end

local counter = 0
local function Constructor()
	counter = counter + 1

	local box = CreateFrame("frame", nil, UIParent)
		box:SetWidth(100)
		box:SetHeight(22)
		box:SetBackdrop(backdrop)
		box:SetBackdropColor(0, 0, 0)
		box:SetBackdropBorderColor(0.4, 0.4, 0.4)
	
	local textArea = CreateFrame("EditBox", nil, box)
		textArea:SetAutoFocus(false)
		textArea:SetMultiLine(false)
		textArea:SetFontObject(GameFontHighlightSmall) --GameFontHighlightSmall)
		textArea:SetMaxLetters(99999)
		textArea:EnableMouse(true)
		textArea:SetPoint("LEFT", box, "LEFT", 5, 0)
		textArea:SetPoint("RIGHT", box, "RIGHT", -5, 0)
		textArea:SetHeight(20)
		textArea:SetScript("OnEscapePressed", textArea.ClearFocus)
	box.textArea = textArea
	box.GetText = GetText
	box.SetText = SetText
	box.Enable = Enable
	box.Disable = Disable
	
	return box
end

local function Neutralizer(box)
	box:SetParent(UIParent)
	box:SetText("")
	box.scrollbar:SetValue(0)
	box:Hide()
end

addon:RegisterWidget("editbox", Constructor, Neutralizer)
