local _, addon = ...

print("Load Frame Constructor")

local FrameBackdrop = {
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32,
		insets = { left = 8, right = 8, top = 8, bottom = 8 }
	}

local function SetText(frame, t)
	frame.text:SetText(t)
	frame.titlebg:SetWidth(frame.text:GetWidth())
end

local function GetText(frame)
	return frame.text:GetText()
end

local function Constructor()
	local frame = CreateFrame("Frame", nil, UIParent)
	
	frame:SetFrameStrata("FULLSCREEN_DIALOG")
		
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:SetResizable(true)
	frame:SetBackdrop(FrameBackdrop)
	frame:SetBackdropColor(0, 0, 0, 1)
	frame:SetToplevel(true)
	
	local titlebg = frame:CreateTexture(nil, "OVERLAY")
	titlebg:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	titlebg:SetTexCoord(0.31, 0.67, 0, 0.63)
	titlebg:SetPoint("TOP", 0, 12)
	titlebg:SetWidth(50)
	titlebg:SetHeight(40)
	frame.titlebg = titlebg
	
	local titlebg_l = frame:CreateTexture(nil, "OVERLAY")
	titlebg_l:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	titlebg_l:SetTexCoord(0.21, 0.31, 0, 0.63)
	titlebg_l:SetPoint("RIGHT", titlebg, "LEFT")
	titlebg_l:SetWidth(30)
	titlebg_l:SetHeight(40)

	local titlebg_r = frame:CreateTexture(nil, "OVERLAY")
	titlebg_r:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	titlebg_r:SetTexCoord(0.67, 0.77, 0, 0.63)
	titlebg_r:SetPoint("LEFT", titlebg, "RIGHT")
	titlebg_r:SetWidth(30)
	titlebg_r:SetHeight(40)
	
	local title = CreateFrame("Frame", nil, frame)
	title:EnableMouse(true)
	title:SetScript("OnMouseDown", function(frame)
			frame:GetParent():StartMoving()
		end)
	title:SetScript("OnMouseUp", function(frame)
			frame:GetParent():StopMovingOrSizing()
		end)
	title:SetAllPoints(titlebg)
	
	local titletext = title:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	titletext:SetPoint("TOP", titlebg, "TOP", 3, -14)
	frame.text = titletext
	frame.SetText = SetText
	frame.GetText = GetText

	return frame
end

local function Neutralizer(frame)
	frame:SetParent(UIParent)
	frame:ClearAllPoints()
	frame:SetText("")
	frame:Hide()
end

addon:RegisterWidget("frame", Constructor, Neutralizer)
