local addonname, addon = ...



local function OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	GameTooltip:SetText(self.tooltip)
end

local function OnLeave(self)
	GameTooltip:Hide()
end

local function Constructor()
	local checkbox = CreateFrame("CheckButton", nil, UIParent)
	checkbox:SetWidth(32)
	checkbox:SetHeight(32)
	checkbox:EnableMouse(true)

	local bg = checkbox:CreateTexture(nil, "BACKGROUND")
		bg:SetWidth(64)
		bg:SetHeight(64)
		bg:SetPoint("TOPLEFT", -3, 11)
		bg:SetTexture("Interface\\SpellBook\\SpellBook-SkillLineTab")
	checkbox.bg = bg
	
	local iconborder = checkbox:CreateTexture(nil, "ARTWORK")
		iconborder:SetWidth(32)
		iconborder:SetHeight(32)
		iconborder:SetPoint("TOPLEFT")
		iconborder:SetTexture("Interface\\Spellbook\\GuildSpellbooktabIconFrame")
	checkbox.iconborder = iconborder

	checkbox:SetNormalTexture("Interface\\ICONS\\INV_Misc_QuestionMark", "ADD")
	checkbox:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square", "ADD")
	checkbox:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight", "ADD")
	
	checkbox:SetScript("OnEnter", OnEnter)
	checkbox:SetScript("OnLeave", OnLeave)
	
	return checkbox
end

local function Neutralizer(checkbox)
	checkbox:SetParent(UIParent)
	checkbox:SetChecked(false)
	checkbox:SetScript("OnClick", nil)
	checkbox:SetScript("OnEnter", OnEnter)
	checkbox:SetScript("OnLeave", OnLeave)
	checkbox:Hide()
end

addon:RegisterWidget("SideIconTab", Constructor, Neutralizer)