local _, addon = ...

local function SetText(frame, text)
	return frame.label:SetText(text)
end

local function GetText(frame)
	return frame.label:GetText()
end

local function Enable(frame)
	frame.label:SetTextColor(1,.82,0,1)
end

local function Disable(frame)
	frame.label:SetTextColor(.5,.5,.5,1)
end

local function SetTextColor(frame,r,g,b,a)
	frame.label:SetTextColor(r,g,b,a)
end

local function Constructor()
	local frame = CreateFrame("Frame", nil, UIParent)
	frame:SetWidth(40)
	frame:SetHeight(22)
	
	local label = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		label:SetPoint("LEFT", frame, "LEFT", 5, 0)
		label:SetPoint("RIGHT", frame, "RIGHT", -5, 0)
		label:SetJustifyH("CENTER")
		label:SetHeight(10)
	frame.label = label
	
	frame.SetText = SetText
	frame.GetText = GetText
	frame.Enable = Enable
	frame.Disable = Disable
	frame.SetTextColor = SetTextColor
	
	return frame
end

local function Neutralizer(frame)
	frame:SetText("")
	frame:Enable()
	frame.label:SetJustifyH("CENTER")
	frame:Hide()
end

addon:RegisterWidget("title", Constructor, Neutralizer)
