local _, addon = ...

local function Disable(frame)
	frame.up:Disable()
	frame.down:Disable()
	frame.del:Disable()
	frame:GetFontString():SetTextColor(.5,.5,.5)
end

local function Enable(frame)
	frame.up:Enable()
	frame.down:Enable()
	frame.del:Enable()
	frame:GetFontString():SetTextColor(1,1,1)
end

local function Constructor()
	local listbutton = CreateFrame("Button", nil, UIParent)
		listbutton:SetHeight(22)
		listbutton:SetHighlightTexture([[Interface\QuestFrame\UI-QuestLogTitleHighlight]] , "ADD")
		listbutton:GetHighlightTexture():SetVertexColor(1,1,0.2)
		listbutton:EnableMouse(true)


	local downButton = addon:GetWidget("button")
		downButton:SetParent(listbutton)
		downButton:SetText("|cFFFFFFFF▼|r")
		downButton:SetWidth(24)
		downButton:SetNormalFontObject("ChatFontNormal")
		downButton:SetHighlightFontObject("ChatFontNormal")
		downButton:GetHighlightFontObject():SetTextColor(1,1,0.2)
		downButton:SetDisabledFontObject("ChatFontNormal")
		downButton:SetPoint("RIGHT", listbutton, "RIGHT", 0, 0)
	listbutton.down = downButton

	local upButton = addon:GetWidget("button")
		upButton:SetParent(listbutton)
		upButton:SetText("|cFFFFFFFF▲|r")
		upButton:SetWidth(24)
		upButton:SetNormalFontObject("ChatFontNormal")
		upButton:SetHighlightFontObject("ChatFontNormal")
		upButton:GetHighlightFontObject():SetTextColor(1,1,0.2)
		upButton:SetDisabledFontObject("ChatFontNormal")
		upButton:SetPoint("RIGHT", downButton, "LEFT", 0, 0)
	listbutton.up = upButton

	local deleteButton = addon:GetWidget("button")
		deleteButton:SetParent(listbutton)
		--deleteButton:SetText("|cFFFF0000DELETE|r")
		--deleteButton:SetWidth(70)
		deleteButton:SetText("|cFFFF0000Ø|r")
		deleteButton:SetWidth(24)
		deleteButton:SetPoint("RIGHT", upButton, "LEFT", 0, 0)
	listbutton.del = deleteButton

	
	local check = listbutton:CreateTexture()
		check:SetTexture([[Interface\Buttons\UI-Common-MouseHilight]])
		check:SetBlendMode("ADD")
		check:SetAlpha(.75)
		check:SetPoint("TOPLEFT", listbutton, "TOPLEFT", -50, 3)
		check:SetPoint("BOTTOM", listbutton, "BOTTOM", 0, -3)
		check:SetPoint("RIGHT", deleteButton, "LEFT", 50, 0)
		check:Hide()
	listbutton.check = check
	
	
	local listbuttontext = listbutton:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		listbuttontext:SetPoint("LEFT", listbutton, "LEFT", 2, 0)
		listbuttontext:SetPoint("RIGHT", deleteButton, "LEFT", -2, 0)
		listbuttontext:SetText("TEST TEST TEST TEST")
	listbutton:SetFontString(listbuttontext)
	listbutton:SetNormalFontObject("GameFontNormal")
	listbutton:SetHighlightFontObject("GameFontHighlight")
	
	listbutton:SetScript('OnDisable', Disable)
	listbutton:SetScript('OnEnable', Enable)
	
	return listbutton
end

local function Neutralizer(listbutton)
	listbutton:SetParent(UIParent)
	listbutton:ClearAllPoints()
	listbutton:SetText("")
	listbutton:SetScript("OnClick", nil)
	listbutton:SetScript("OnEnter", nil)
	listbutton:SetScript("OnLeave", nil)
	listbutton.up:SetScript("OnClick", nil)
	listbutton.down:SetScript("OnClick", nil)
	listbutton.del:SetScript("OnClick", nil)
	listbutton:Enable()
	listbutton.up:Enable()
	listbutton.down:Enable()
	listbutton.del:Enable()
	listbutton.check:Hide()
	listbutton:Hide()
end

addon:RegisterWidget("UpDownDeleteButton", Constructor, Neutralizer)
